/*
 * The MIT License
 *
 * Original work sponsored and donated by The Danish Health Data Authority (http://www.sundhedsdatastyrelsen.dk)
 *
 * Copyright (C) 2017 The Danish Health Data Authority (http://www.sundhedsdatastyrelsen.dk)
 *
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to
 * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is furnished to do
 * so, subject to the following conditions:
 *
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
/**
* The MIT License
*   
* Original work sponsored and donated by The Danish Health Data Authority (http://www.sundhedsdatastyrelsen.dk)
*   
* Copyright (C) 2018 The Danish Health Data Authority (http://www.sundhedsdatastyrelsen.dk)
*   
*   
* Permission is hereby granted, free of charge, to any person obtaining a copy of
* this software and associated documentation files (the "Software"), to deal in
* the Software without restriction, including without limitation the rights to
* use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
* of the Software, and to permit persons to whom the Software is furnished to do
* so, subject to the following conditions:
*   
*   
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
*   
*   
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*/ 
package dk.stamkort.util.dgws;

import dk.sosi.seal.SOSIFactory;
import dk.sosi.seal.model.*;
import org.springframework.core.io.Resource;

import java.io.IOException;

public class HealthCareProfessionalMocesContext extends DgwsNspUserContext {

	CareProvider careProvider;

	public HealthCareProfessionalMocesContext(STSRequestHelper requestHelper, Resource keystore, String password,
                                              String alias, String patientId, String userCivilRegistrationNumber, String userAuthorizationCode,
                                              String userGivenName, String userSurName, String userEmail, String userOccupation,
                                              String userOrganizationCode, CareProvider careProvider, boolean consentOverride) throws IOException {
		super(requestHelper, keystore, password, alias, patientId, new UserInfo(userCivilRegistrationNumber,
				userGivenName, userSurName, userEmail, userOccupation, userOccupation, userAuthorizationCode),
				userOrganizationCode, null, consentOverride);
		this.careProvider = careProvider;
	}

	@Override
	protected boolean signSosiCardRequests() {
		return true;
	}

	@Override
	public SystemIDCard createNewIdCard(SOSIFactory sosi) {
		UserIDCard selfSignedUserIdCard = sosi.createNewUserIDCard("Test", getUserInfo(), this.careProvider,
				AuthenticationLevel.MOCES_TRUSTED_USER, null, null, x509.getCertificate(), null);
		return selfSignedUserIdCard;
	}
}
